//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//+------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  LimeGreen
#property indicator_width3  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int StoLength      = 14;
extern int StoSmoothing   =  3;
extern int Price          = 0;
extern int DonchianLength = 20;
extern int DonchianShift  = 1;

//
//
//
//
//

double sto[];
double dup[];
double ddn[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,dup);
   SetIndexBuffer(1,ddn);
   SetIndexBuffer(2,sto);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      sto[i] = iStochastic(NULL,0,StoLength,1,StoSmoothing,MODE_SMA,Price,MODE_MAIN,i);
      dup[i] = sto[ArrayMaximum(sto,DonchianLength,i+DonchianShift)];
      ddn[i] = sto[ArrayMinimum(sto,DonchianLength,i+DonchianShift)];
   }
   return(0);
}